/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-10-09 17:02
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

string s;
ll N, pos;

void solve(){
    // Code goes here ...
    cin >> s;
    cin >> pos;
    N = ssize(s);

    vector<ll> decr(N);
    decr[N - 1] = 1;
    char succ = s[N - 1], cur;
    for(int i = N - 2; i >= 0; i--){
        cur = s[i];
        if(cur == succ){
            decr[i] = decr[i + 1];
        }
        if(cur < succ){
            decr[i] = 0;
        }
        if(cur > succ){
            decr[i] = 1;
        }
        succ = cur;
    }

    vector<ll> delpos(N);
    ll frontcounter = 1, backcounter = N;
    for(int i = 0; i < N; i++){
        delpos[i] = decr[i] ? frontcounter++ : backcounter--;
    }
    for(auto ele : delpos)
        cerr << ele << " ";
    cerr << endl;

    int cnt = N;
    while(pos - cnt > 0) pos -= cnt, cnt--;
    int numdeleted = N - cnt;

    int ocnt = 0;
    bool res = 0;
    // cerr << "check >=" << N - pos << "; times " << pos << endl;
    R(i, N){
        cerr << delpos[i] << " ?> " << numdeleted << endl;
        if(delpos[i] > numdeleted){
            ocnt++;
        }
        if(ocnt == pos){
            putchar(s[i]);
            res = true;
            break;
        }
    }
    assert(res);
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    printf("\n");

    return 0;
}
        
